diff --git a/src/libs/zbxcrypto/tls.c b/src/libs/zbxcrypto/tls.c
index 7338883..b720452 100644
--- a/src/libs/zbxcrypto/tls.c
+++ b/src/libs/zbxcrypto/tls.c
@@ -4543,6 +5606,211 @@ out1:
 			ZBX_NULL2EMPTY_STR(*error));
 	return ret;
 }
+#elif defined(HAVE_MBEDTLS21)
+int	zbx_tls_accept(zbx_socket_t *s, unsigned int tls_accept, char **error)
+{
+	const char		*__function_name = "zbx_tls_accept";
+	int			ret = FAIL, res;
+	const mbedtls_ssl_ciphersuite_t	*info;
+#if defined(_WINDOWS)
+	double			sec;
+#endif
+	zabbix_log(LOG_LEVEL_DEBUG, "In %s()", __function_name);
+
+	/* set up TLS context */
+
+	s->tls_ctx = zbx_malloc(s->tls_ctx, sizeof(zbx_tls_context_t));
+	s->tls_ctx->conf = zbx_malloc(NULL, sizeof(mbedtls_ssl_config));
+	mbedtls_ssl_config_init(s->tls_ctx->conf);
+	s->tls_ctx->ctx = zbx_malloc(NULL, sizeof(mbedtls_ssl_context));
+	mbedtls_ssl_init(s->tls_ctx->ctx);
+
+	if (0 != (res = mbedtls_ssl_config_defaults(s->tls_ctx->conf,
+			MBEDTLS_SSL_IS_SERVER, MBEDTLS_SSL_TRANSPORT_STREAM, MBEDTLS_SSL_PRESET_DEFAULT)))
+	{
+		zbx_tls_error_msg(res, "mbedtls_ssl_config_defaults(): ", error);
+		goto out_pre_setup;
+	}
+
+	if (0 != (res = mbedtls_ssl_setup(s->tls_ctx->ctx, s->tls_ctx->conf)))
+	{
+		zbx_tls_error_msg(res, "mbedtls_ssl_setup(): ", error);
+		goto out;
+	}
+
+	/* Set RNG callback where to get random numbers from */
+	mbedtls_ssl_conf_rng(s->tls_ctx->conf, mbedtls_ctr_drbg_random, ctr_drbg);
+
+	/* explicitly disable using of session tickets (although by default it is disabled on server) */
+	mbedtls_ssl_conf_session_tickets(s->tls_ctx->conf, MBEDTLS_SSL_SESSION_TICKETS_DISABLED);
+
+	if (SUCCEED == zabbix_check_log_level(LOG_LEVEL_TRACE))
+	{
+		/* Set our own debug callback function. The 3rd parameter of mbedtls_ssl_conf_dbg() we set to NULL. It will be */
+		/* passed as the 1st parameter to our callback function and will be ignored there. */
+		mbedtls_ssl_conf_dbg(s->tls_ctx->conf, polarssl_debug_cb, NULL);
+
+		/* For Zabbix LOG_LEVEL_TRACE, PolarSSL debug level 3 seems the best. Recompile with 4 (apparently */
+		/* the highest PolarSSL debug level) to dump also network raw bytes. */
+		mbedtls_debug_set_threshold(3);
+	}
+
+	/* Set callback functions for receiving and sending data via socket. */
+	/* Functions provided by PolarSSL work well so far, no need to invent our own. */
+	mbedtls_ssl_set_bio(s->tls_ctx->ctx, &s->socket, mbedtls_net_send, mbedtls_net_recv, NULL);
+
+	/* set protocol version to TLS 1.2 */
+	mbedtls_ssl_conf_min_version(s->tls_ctx->conf, ZBX_TLS_MIN_MAJOR_VER, ZBX_TLS_MIN_MINOR_VER);
+	mbedtls_ssl_conf_max_version(s->tls_ctx->conf, ZBX_TLS_MAX_MAJOR_VER, ZBX_TLS_MAX_MINOR_VER);
+
+	/* prepare to accept with certificate */
+
+	if (0 != (tls_accept & ZBX_TCP_SEC_TLS_CERT))
+	{
+		mbedtls_ssl_conf_authmode(s->tls_ctx->conf, MBEDTLS_SSL_VERIFY_REQUIRED);
+
+		/* set CA certificate and certificate revocation lists */
+		if (NULL != ca_cert)
+			mbedtls_ssl_conf_ca_chain(s->tls_ctx->conf, ca_cert, crl);
+
+		if (NULL != my_cert && 0 != (res = mbedtls_ssl_conf_own_cert(s->tls_ctx->conf, my_cert, my_priv_key)))
+		{
+			zbx_tls_error_msg(res, "mbedtls_ssl_conf_own_cert(): ", error);
+			goto out;
+		}
+	}
+
+	/* prepare to accept with pre-shared key */
+
+	if (0 != (tls_accept & ZBX_TCP_SEC_TLS_PSK))
+	{
+		/* for agentd the only possibility is a PSK from configuration file */
+		if (0 != (program_type & ZBX_PROGRAM_TYPE_AGENTD) &&
+				0 != (res = mbedtls_ssl_conf_psk(s->tls_ctx->conf, (const unsigned char *)my_psk, my_psk_len,
+				(const unsigned char *)my_psk_identity, my_psk_identity_len)))
+		{
+			zbx_tls_error_msg(res, "mbedtls_ssl_conf_psk(): ", error);
+			goto out;
+		}
+		else if (0 != (program_type & (ZBX_PROGRAM_TYPE_PROXY | ZBX_PROGRAM_TYPE_SERVER)))
+		{
+			/* For server or proxy a PSK can come from configuration file or database. */
+			/* Set up a callback function for finding the requested PSK. */
+			mbedtls_ssl_conf_psk_cb(s->tls_ctx->conf, zbx_psk_cb, NULL);
+		}
+	}
+
+	/* set up ciphersuites */
+
+	if ((ZBX_TCP_SEC_TLS_CERT | ZBX_TCP_SEC_TLS_PSK) == (tls_accept & (ZBX_TCP_SEC_TLS_CERT | ZBX_TCP_SEC_TLS_PSK)))
+	{
+		/* common case in trapper - be ready for all types of incoming connections */
+		if (NULL != my_cert)
+		{
+			/* it can also be a case in agentd listener - when both certificate and PSK is allowed, e.g. */
+			/* for switching of TLS connections from PSK to using a certificate */
+			mbedtls_ssl_conf_ciphersuites(s->tls_ctx->conf, ciphersuites_all);
+		}
+		else
+		{
+			/* assume PSK, although it is not yet known will there be the right PSK available */
+			mbedtls_ssl_conf_ciphersuites(s->tls_ctx->conf, ciphersuites_psk);
+		}
+	}
+	else if (0 != (tls_accept & ZBX_TCP_SEC_TLS_CERT) && NULL != my_cert)
+		mbedtls_ssl_conf_ciphersuites(s->tls_ctx->conf, ciphersuites_cert);
+	else if (0 != (tls_accept & ZBX_TCP_SEC_TLS_PSK))
+		mbedtls_ssl_conf_ciphersuites(s->tls_ctx->conf, ciphersuites_psk);
+
+	/* TLS handshake */
+
+#if defined(_WINDOWS)
+	zbx_alarm_flag_clear();
+	sec = zbx_time();
+#endif
+	while (0 != (res = mbedtls_ssl_handshake(s->tls_ctx->ctx)))
+	{
+#if defined(_WINDOWS)
+		if (s->timeout < zbx_time() - sec)
+			zbx_alarm_flag_set();
+#endif
+		if (SUCCEED == zbx_alarm_timed_out())
+		{
+			*error = zbx_strdup(*error, "mbedtls_ssl_handshake() timed out");
+			goto out;
+		}
+
+		if (MBEDTLS_ERR_SSL_WANT_READ != res && MBEDTLS_ERR_SSL_WANT_WRITE != res)
+		{
+			if (MBEDTLS_ERR_X509_CERT_VERIFY_FAILED == res)
+			{
+				/* Standard PolarSSL error message might not be very informative in this case. For */
+				/* example, if certificate validity starts in future, PolarSSL 1.3.9 would produce a */
+				/* message "X509 - Certificate verification failed, e.g. CRL, CA or signature check */
+				/* failed" which does not give a precise reason. Here we try to get more detailed */
+				/* reason why peer certificate was rejected by using some knowledge about PolarSSL */
+				/* internals. */
+				zbx_tls_cert_error_msg((unsigned int)s->tls_ctx->ctx->session_negotiate->verify_result,
+						error);
+				zbx_tls_close(s);
+				goto out1;
+			}
+
+			zbx_tls_error_msg(res, "mbedtls_ssl_handshake(): ", error);
+			goto out;
+		}
+	}
+
+	/* Is this TLS conection using certificate or PSK? */
+
+	info = mbedtls_ssl_ciphersuite_from_id(s->tls_ctx->ctx->session->ciphersuite);
+
+	if (MBEDTLS_KEY_EXCHANGE_PSK == info->key_exchange ||
+			MBEDTLS_KEY_EXCHANGE_DHE_PSK == info->key_exchange ||
+			MBEDTLS_KEY_EXCHANGE_ECDHE_PSK == info->key_exchange ||
+			MBEDTLS_KEY_EXCHANGE_RSA_PSK == info->key_exchange)
+	{
+		s->connection_type = ZBX_TCP_SEC_TLS_PSK;
+
+		if (SUCCEED == zabbix_check_log_level(LOG_LEVEL_DEBUG))
+		{
+			/* special print: s->tls_ctx->ctx->psk_identity is not '\0'-terminated */
+			zabbix_log(LOG_LEVEL_DEBUG, "%s() PSK identity: \"%.*s\"", __function_name,
+					(int)s->tls_ctx->conf->psk_identity_len, s->tls_ctx->conf->psk_identity);
+		}
+	}
+	else
+	{
+		s->connection_type = ZBX_TCP_SEC_TLS_CERT;
+
+		/* log peer certificate information for debugging */
+		zbx_log_peer_cert(__function_name, s->tls_ctx);
+
+		/* basic verification of peer certificate was done during handshake */
+
+		/* Issuer and Subject will be verified later, after receiving sender type and host name */
+	}
+
+	if (SUCCEED == zabbix_check_log_level(LOG_LEVEL_DEBUG))
+	{
+		zabbix_log(LOG_LEVEL_DEBUG, "End of %s():SUCCEED (established %s %s)", __function_name,
+				mbedtls_ssl_get_version(s->tls_ctx->ctx), mbedtls_ssl_get_ciphersuite(s->tls_ctx->ctx));
+	}
+
+	return SUCCEED;
+
+out:	/* an error occurred */
+	mbedtls_ssl_free(s->tls_ctx->ctx);
+	zbx_free(s->tls_ctx->ctx);
+out_pre_setup:
+	mbedtls_ssl_config_free(s->tls_ctx->conf);
+	zbx_free(s->tls_ctx->conf);
+	zbx_free(s->tls_ctx);
+out1:
+	zabbix_log(LOG_LEVEL_DEBUG, "End of %s():%s error:'%s'", __function_name, zbx_result_string(ret),
+			ZBX_NULL2EMPTY_STR(*error));
+	return ret;
+}
 #elif defined(HAVE_GNUTLS)
 int	zbx_tls_accept(zbx_socket_t *s, unsigned int tls_accept, char **error)
 {
@@ -5041,6 +6309,13 @@ out1:
 #	define ZBX_TLS_READ_FUNC_NAME		"ssl_read"
 #	define ZBX_TLS_WANT_WRITE(res)		(POLARSSL_ERR_NET_WANT_WRITE == (res) ? SUCCEED : FAIL)
 #	define ZBX_TLS_WANT_READ(res)		(POLARSSL_ERR_NET_WANT_READ == (res) ? SUCCEED : FAIL)
+#elif defined(HAVE_MBEDTLS21)
+#	define ZBX_TLS_WRITE(ctx, buf, len)	mbedtls_ssl_write(ctx, (const unsigned char *)(buf), len)
+#	define ZBX_TLS_READ(ctx, buf, len)	mbedtls_ssl_read(ctx, (unsigned char *)(buf), len)
+#	define ZBX_TLS_WRITE_FUNC_NAME		"mbedtls_ssl_write"
+#	define ZBX_TLS_READ_FUNC_NAME		"mbedtls_ssl_read"
+#	define ZBX_TLS_WANT_WRITE(res)		(MBEDTLS_ERR_SSL_WANT_WRITE == (res) ? SUCCEED : FAIL)
+#	define ZBX_TLS_WANT_READ(res)		(MBEDTLS_ERR_SSL_WANT_READ == (res) ? SUCCEED : FAIL)
 #elif defined(HAVE_GNUTLS)
 #	define ZBX_TLS_WRITE(ctx, buf, len)	gnutls_record_send(ctx, buf, len)
 #	define ZBX_TLS_READ(ctx, buf, len)	gnutls_record_recv(ctx, buf, len)
@@ -5066,6 +6341,8 @@ ssize_t	zbx_tls_write(zbx_socket_t *s, const char *buf, size_t len, char **error
 #endif
 #if defined(HAVE_POLARSSL)
 	int	res;
+#elif defined(HAVE_MBEDTLS21)
+	int	res;
 #elif defined(HAVE_GNUTLS)
 	ssize_t	res;
 #elif defined(HAVE_OPENSSL)
@@ -5101,6 +6378,16 @@ ssize_t	zbx_tls_write(zbx_socket_t *s, const char *buf, size_t len, char **error
 
 		return ZBX_PROTO_ERROR;
 	}
+#elif defined(HAVE_MBEDTLS21)
+	if (0 > res)
+	{
+		char	err[128];	/* 128 bytes are enough for PolarSSL error messages */
+
+		mbedtls_strerror(res, err, sizeof(err));
+		*error = zbx_dsprintf(*error, "mbedtls_ssl_write() failed: %s", err);
+
+		return ZBX_PROTO_ERROR;
+	}
 #elif defined(HAVE_GNUTLS)
 	if (0 > res)
 	{
@@ -5147,6 +6434,8 @@ ssize_t	zbx_tls_read(zbx_socket_t *s, char *buf, size_t len, char **error)
 #endif
 #if defined(HAVE_POLARSSL)
 	int	res;
+#elif defined(HAVE_MBEDTLS21)
+	int	res;
 #elif defined(HAVE_GNUTLS)
 	ssize_t	res;
 #elif defined(HAVE_OPENSSL)
@@ -5182,6 +6471,16 @@ ssize_t	zbx_tls_read(zbx_socket_t *s, char *buf, size_t len, char **error)
 
 		return ZBX_PROTO_ERROR;
 	}
+#elif defined(HAVE_MBEDTLS21)
+	if (0 > res)
+	{
+		char	err[128];	/* 128 bytes are enough for PolarSSL error messages */
+
+		mbedtls_strerror(res, err, sizeof(err));
+		*error = zbx_dsprintf(*error, "mbedtls_ssl_read() failed: %s", err);
+
+		return ZBX_PROTO_ERROR;
+	}
 #elif defined(HAVE_GNUTLS)
 	if (0 > res)
 	{
@@ -5264,6 +6563,35 @@ void	zbx_tls_close(zbx_socket_t *s)
 		ssl_free(s->tls_ctx->ctx);
 		zbx_free(s->tls_ctx->ctx);
 	}
+#elif defined(HAVE_MBEDTLS21)
+	if (NULL != s->tls_ctx->ctx)
+	{
+#if defined(_WINDOWS)
+		double	sec;
+
+		zbx_alarm_flag_clear();
+		sec = zbx_time();
+#endif
+		while (0 > (res = mbedtls_ssl_close_notify(s->tls_ctx->ctx)))
+		{
+#if defined(_WINDOWS)
+			if (s->timeout < zbx_time() - sec)
+				zbx_alarm_flag_set();
+#endif
+			if (SUCCEED == zbx_alarm_timed_out())
+				break;
+
+			if (MBEDTLS_ERR_SSL_WANT_READ != res && MBEDTLS_ERR_SSL_WANT_WRITE != res)
+			{
+				zabbix_log(LOG_LEVEL_WARNING, "mbedtls_ssl_close_notify() with %s returned error code: %d",
+						s->peer, res);
+				break;
+			}
+		}
+
+		mbedtls_ssl_free(s->tls_ctx->ctx);
+		zbx_free(s->tls_ctx->ctx);
+	}
 #elif defined(HAVE_GNUTLS)
 	if (NULL != s->tls_ctx->ctx)
 	{
@@ -5339,6 +6667,8 @@ int	zbx_tls_get_attr_cert(const zbx_socket_t *s, zbx_tls_conn_attr_t *attr)
 	char			*error = NULL;
 #if defined(HAVE_POLARSSL)
 	const x509_crt		*peer_cert;
+#elif defined(HAVE_MBEDTLS21)
+	const mbedtls_x509_crt		*peer_cert;
 #elif defined(HAVE_GNUTLS)
 	gnutls_x509_crt_t	peer_cert;
 	gnutls_x509_dn_t	dn;
@@ -5367,6 +6697,26 @@ int	zbx_tls_get_attr_cert(const zbx_socket_t *s, zbx_tls_conn_attr_t *attr)
 		zbx_free(error);
 		return FAIL;
 	}
+#elif defined(HAVE_MBEDTLS21)
+	if (NULL == (peer_cert = mbedtls_ssl_get_peer_cert(s->tls_ctx->ctx)))
+	{
+		zabbix_log(LOG_LEVEL_WARNING, "no peer certificate, mbedtls_ssl_get_peer_cert() returned NULL");
+		return FAIL;
+	}
+
+	if (SUCCEED != zbx_x509_dn_gets(&peer_cert->issuer, attr->issuer, sizeof(attr->issuer), &error))
+	{
+		zabbix_log(LOG_LEVEL_WARNING, "error while getting issuer name: \"%s\"", error);
+		zbx_free(error);
+		return FAIL;
+	}
+
+	if (SUCCEED != zbx_x509_dn_gets(&peer_cert->subject, attr->subject, sizeof(attr->subject), &error))
+	{
+		zabbix_log(LOG_LEVEL_WARNING, "error while getting subject name: \"%s\"", error);
+		zbx_free(error);
+		return FAIL;
+	}
 #elif defined(HAVE_GNUTLS)
 	/* here is some inefficiency - we do not know will it be required to verify peer certificate issuer */
 	/* and subject - but we prepare for it */
@@ -5457,6 +6807,9 @@ int	zbx_tls_get_attr_psk(const zbx_socket_t *s, zbx_tls_conn_attr_t *attr)
 #if defined(HAVE_POLARSSL)
 	attr->psk_identity = (char *)s->tls_ctx->ctx->psk_identity;
 	attr->psk_identity_len = s->tls_ctx->ctx->psk_identity_len;
+#elif defined(HAVE_MBEDTLS21)
+	attr->psk_identity = (char *)s->tls_ctx->conf->psk_identity;
+	attr->psk_identity_len = s->tls_ctx->conf->psk_identity_len;
 #elif defined(HAVE_GNUTLS)
 	if (NULL != (attr->psk_identity = gnutls_psk_server_get_username(s->tls_ctx->ctx)))
 		attr->psk_identity_len = strlen(attr->psk_identity);
@@ -5497,6 +6850,19 @@ void	zbx_tls_pass_vars(ZBX_THREAD_SENDVAL_TLS_ARGS *args)
 	args->ctr_drbg = ctr_drbg;
 	args->ciphersuites_cert = ciphersuites_cert;
 	args->ciphersuites_psk = ciphersuites_psk;
+#elif defined(HAVE_MBEDTLS21)
+	args->my_psk = my_psk;
+	args->my_psk_len = my_psk_len;
+	args->my_psk_identity = my_psk_identity;
+	args->my_psk_identity_len = my_psk_identity_len;
+	args->ca_cert = ca_cert;
+	args->crl = crl;
+	args->my_cert = my_cert;
+	args->my_priv_key = my_priv_key;
+	args->entropy = entropy;
+	args->ctr_drbg = ctr_drbg;
+	args->ciphersuites_cert = ciphersuites_cert;
+	args->ciphersuites_psk = ciphersuites_psk;
 #elif defined(HAVE_GNUTLS)
 	args->my_cert_creds = my_cert_creds;
 	args->my_psk_client_creds = my_psk_client_creds;
@@ -5536,6 +6902,19 @@ void	zbx_tls_take_vars(ZBX_THREAD_SENDVAL_TLS_ARGS *args)
 	ctr_drbg = args->ctr_drbg;
 	ciphersuites_cert = args->ciphersuites_cert;
 	ciphersuites_psk = args->ciphersuites_psk;
+#elif defined(HAVE_MBEDTLS21)
+	my_psk = args->my_psk;
+	my_psk_len = args->my_psk_len;
+	my_psk_identity = args->my_psk_identity;
+	my_psk_identity_len = args->my_psk_identity_len;
+	ca_cert = args->ca_cert;
+	crl = args->crl;
+	my_cert = args->my_cert;
+	my_priv_key = args->my_priv_key;
+	entropy = args->entropy;
+	ctr_drbg = args->ctr_drbg;
+	ciphersuites_cert = args->ciphersuites_cert;
+	ciphersuites_psk = args->ciphersuites_psk;
 #elif defined(HAVE_GNUTLS)
 	my_cert_creds = args->my_cert_creds;
 	my_psk_client_creds = args->my_psk_client_creds;
diff --git a/src/libs/zbxcrypto/tls.h b/src/libs/zbxcrypto/tls.h
index 48b02a8..ad05172 100644
--- a/src/libs/zbxcrypto/tls.h
+++ b/src/libs/zbxcrypto/tls.h
@@ -20,7 +20,7 @@
 #ifndef ZABBIX_TLS_H
 #define ZABBIX_TLS_H
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 
 #if defined(_WINDOWS)
 /* Typical thread is long-running, if necessary, it initializes TLS for itself. Zabbix sender is an exception. If */
@@ -32,6 +32,10 @@
 #	include <polarssl/entropy.h>
 #	include <polarssl/ctr_drbg.h>
 #	include <polarssl/ssl.h>
+#elif defined(HAVE_MBEDTLS21)
+#	include <mbedtls/entropy.h>
+#	include <mbedtls/ctr_drbg.h>
+#	include <mbedtls/ssl.h>
 #elif defined(HAVE_GNUTLS)
 #	include <gnutls/gnutls.h>
 #elif defined(HAVE_OPENSSL)
@@ -53,6 +57,19 @@ typedef struct
 	ctr_drbg_context	*ctr_drbg;
 	int			*ciphersuites_cert;
 	int			*ciphersuites_psk;
+#elif defined(HAVE_MBEDTLS21)
+	char				*my_psk;
+	size_t				my_psk_len;
+	char				*my_psk_identity;
+	size_t				my_psk_identity_len;
+	mbedtls_x509_crt		*ca_cert;
+	mbedtls_x509_crl		*crl;
+	mbedtls_x509_crt		*my_cert;
+	mbedtls_pk_context		*my_priv_key;
+	mbedtls_entropy_context		*entropy;
+	mbedtls_ctr_drbg_context	*ctr_drbg;
+	int				*ciphersuites_cert;
+	int				*ciphersuites_psk;
 #elif defined(HAVE_GNUTLS)
 	gnutls_certificate_credentials_t	my_cert_creds;
 	gnutls_psk_client_credentials_t		my_psk_client_creds;
@@ -80,6 +97,6 @@ void	zbx_tls_init_child(void);
 void	zbx_tls_free(void);
 void	zbx_tls_free_on_signal(void);
 
-#endif	/* #if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL) */
+#endif	/* #if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL) */
 
 #endif	/* ZABBIX_TLS_H */
diff --git a/src/libs/zbxcrypto/tls_tcp.h b/src/libs/zbxcrypto/tls_tcp.h
index 104af9d..2abd8ba 100644
--- a/src/libs/zbxcrypto/tls_tcp.h
+++ b/src/libs/zbxcrypto/tls_tcp.h
@@ -20,7 +20,7 @@
 #ifndef ZABBIX_TLS_TCP_H
 #define ZABBIX_TLS_TCP_H
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 int	zbx_tls_connect(zbx_socket_t *s, unsigned int tls_connect, char *tls_arg1, char *tls_arg2, char **error);
 int	zbx_tls_accept(zbx_socket_t *s, unsigned int tls_accept, char **error);
 ssize_t	zbx_tls_write(zbx_socket_t *s, const char *buf, size_t len, char **error);
diff --git a/src/libs/zbxcrypto/tls_tcp_active.h b/src/libs/zbxcrypto/tls_tcp_active.h
index fcd1cc5..a1cd447 100644
--- a/src/libs/zbxcrypto/tls_tcp_active.h
+++ b/src/libs/zbxcrypto/tls_tcp_active.h
@@ -20,7 +20,7 @@
 #ifndef ZABBIX_TLS_TCP_ACTIVE_H
 #define ZABBIX_TLS_TCP_ACTIVE_H
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 typedef struct
 {
 	const char	*psk_identity;
diff --git a/src/libs/zbxdbcache/dbconfig.c b/src/libs/zbxdbcache/dbconfig.c
index efb477d..e8237fe 100644
--- a/src/libs/zbxdbcache/dbconfig.c
+++ b/src/libs/zbxdbcache/dbconfig.c
@@ -809,14 +809,14 @@ static void	DCsync_hosts(zbx_dbsync_t *sync)
 	time_t			now;
 	signed char		ipmi_authtype;
 	unsigned char		ipmi_privilege;
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	ZBX_DC_PSK		*psk_i, psk_i_local;
 	zbx_ptr_pair_t		*psk_owner, psk_owner_local;
 	zbx_hashset_t		psk_owners;
 #endif
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s()", __function_name);
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	zbx_hashset_create(&psk_owners, 0, ZBX_DEFAULT_PTR_HASH_FUNC, ZBX_DEFAULT_PTR_COMPARE_FUNC);
 #endif
 	now = time(NULL);
@@ -889,7 +889,7 @@ static void	DCsync_hosts(zbx_dbsync_t *sync)
 
 		DCstrpool_replace(found, &host->host, row[2]);
 		DCstrpool_replace(found, &host->name, row[23]);
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 		DCstrpool_replace(found, &host->tls_issuer, row[31]);
 		DCstrpool_replace(found, &host->tls_subject, row[32]);
 
@@ -1273,7 +1273,7 @@ done:
 		zbx_strpool_release(host->snmp_error);
 		zbx_strpool_release(host->ipmi_error);
 		zbx_strpool_release(host->jmx_error);
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 		zbx_strpool_release(host->tls_issuer);
 		zbx_strpool_release(host->tls_subject);
 
@@ -1294,7 +1294,7 @@ done:
 		zbx_hashset_remove_direct(&config->hosts, host);
 	}
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	zbx_hashset_destroy(&psk_owners);
 #endif
 
@@ -3674,7 +3674,7 @@ void	DCsync_configuration(unsigned char mode)
 				config->hosts_h.num_data, config->hosts_h.num_slots);
 		zabbix_log(LOG_LEVEL_DEBUG, "%s() hosts_p    : %d (%d slots)", __function_name,
 				config->hosts_p.num_data, config->hosts_p.num_slots);
-	#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+	#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 		zabbix_log(LOG_LEVEL_DEBUG, "%s() psks       : %d (%d slots)", __function_name,
 				config->psks.num_data, config->psks.num_slots);
 	#endif
@@ -4065,7 +4065,7 @@ static int	__config_regexp_compare(const void *d1, const void *d2)
 	return r1->name == r2->name ? 0 : strcmp(r1->name, r2->name);
 }
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 static zbx_hash_t	__config_psk_hash(const void *data)
 {
 	const ZBX_DC_PSK	*psk_i = (const ZBX_DC_PSK *)data;
@@ -4178,7 +4178,7 @@ void	init_configuration_cache(void)
 			__config_mem_realloc_func,
 			__config_mem_free_func);
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	CREATE_HASHSET_EXT(config->psks, 0, __config_psk_hash, __config_psk_compare);
 #endif
 	for (i = 0; i < CONFIG_TIMER_FORKS; i++)
@@ -4329,7 +4329,7 @@ static void	DCget_host(DC_HOST *dst_host, const ZBX_DC_HOST *src_host)
 	strscpy(dst_host->jmx_error, src_host->jmx_error);
 	dst_host->tls_connect = src_host->tls_connect;
 	dst_host->tls_accept = src_host->tls_accept;
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	strscpy(dst_host->tls_issuer, src_host->tls_issuer);
 	strscpy(dst_host->tls_subject, src_host->tls_subject);
 
@@ -4421,7 +4421,7 @@ int	DCget_host_by_hostid(DC_HOST *host, zbx_uint64_t hostid)
 int	DCcheck_proxy_permissions(const char *host, const zbx_socket_t *sock, zbx_uint64_t *hostid, char **error)
 {
 	const ZBX_DC_HOST	*dc_host;
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	zbx_tls_conn_attr_t	attr;
 
 	if (ZBX_TCP_SEC_TLS_CERT == sock->connection_type)
@@ -4473,7 +4473,7 @@ int	DCcheck_proxy_permissions(const char *host, const zbx_socket_t *sock, zbx_ui
 		return FAIL;
 	}
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	if (ZBX_TCP_SEC_TLS_CERT == sock->connection_type)
 	{
 		/* simplified match, not compliant with RFC 4517, 4518 */
@@ -4521,7 +4521,7 @@ int	DCcheck_proxy_permissions(const char *host, const zbx_socket_t *sock, zbx_ui
 	return SUCCEED;
 }
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 /******************************************************************************
  *                                                                            *
  * Function: DCget_psk_by_identity                                            *
@@ -6898,7 +6898,7 @@ static void	DCget_proxy(DC_PROXY *dst_proxy, ZBX_DC_PROXY *src_proxy)
 		strscpy(dst_proxy->host, host->host);
 		dst_proxy->tls_connect = host->tls_connect;
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 		if (ZBX_TCP_SEC_TLS_CERT == host->tls_connect)
 		{
 			strscpy(dst_proxy->tls_arg1, host->tls_issuer);
@@ -6922,7 +6922,7 @@ static void	DCget_proxy(DC_PROXY *dst_proxy, ZBX_DC_PROXY *src_proxy)
 		/* process_proxy(). So, this branch should never happen. */
 		*dst_proxy->host = '\0';
 		dst_proxy->tls_connect = ZBX_TCP_SEC_TLS_PSK;	/* set PSK to deliberately fail in this case */
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 		*dst_proxy->tls_arg1 = '\0';
 		*dst_proxy->tls_arg2 = '\0';
 #endif
diff --git a/src/libs/zbxdbcache/dbconfig.h b/src/libs/zbxdbcache/dbconfig.h
index aa0ec44..fb207a1 100644
--- a/src/libs/zbxdbcache/dbconfig.h
+++ b/src/libs/zbxdbcache/dbconfig.h
@@ -214,7 +214,7 @@ ZBX_DC_CALCITEM;
 
 typedef zbx_item_history_value_t	ZBX_DC_DELTAITEM;
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 typedef struct
 {
 	const char	*tls_psk_identity;	/* pre-shared key identity           */
@@ -267,7 +267,7 @@ typedef struct
 	/* 'tls_connect' and 'tls_accept' must be respected even if encryption support is not compiled in */
 	unsigned char	tls_connect;
 	unsigned char	tls_accept;
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	const char	*tls_issuer;
 	const char	*tls_subject;
 	ZBX_DC_PSK	*tls_dc_psk;
@@ -487,7 +487,7 @@ typedef struct
 	zbx_hashset_t		expressions;
 	zbx_hashset_t		actions;
 	zbx_hashset_t		action_conditions;
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	zbx_hashset_t		psks;			/* for keeping PSK-identity and PSK pairs and for searching */
 							/* by PSK identity */
 #endif
diff --git a/src/libs/zbxdbcache/dbconfig_dump.c b/src/libs/zbxdbcache/dbconfig_dump.c
index 47b9d4b..da47087 100644
--- a/src/libs/zbxdbcache/dbconfig_dump.c
+++ b/src/libs/zbxdbcache/dbconfig_dump.c
@@ -119,7 +119,7 @@ static void	DCdump_hosts(ZBX_DC_CONFIG *config)
 
 		/* 'tls_connect' and 'tls_accept' must be respected even if encryption support is not compiled in */
 		zabbix_log(LOG_LEVEL_TRACE, "  tls:[connect:%u accept:%u]", host->tls_connect, host->tls_accept);
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 		zabbix_log(LOG_LEVEL_TRACE, "  tls:[issuer:'%s' subject:'%s']", host->tls_issuer, host->tls_subject);
 
 		if (NULL != host->tls_dc_psk)
diff --git a/src/libs/zbxdbcache/dbsync.c b/src/libs/zbxdbcache/dbsync.c
index 74cddf3..815840f 100644
--- a/src/libs/zbxdbcache/dbsync.c
+++ b/src/libs/zbxdbcache/dbsync.c
@@ -423,7 +423,7 @@ static int	dbsync_compare_host(ZBX_DC_HOST *host, const DB_ROW row)
 	if (FAIL == dbsync_compare_str(row[23], host->name))
 		return FAIL;
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	if (FAIL == dbsync_compare_str(row[31], host->tls_issuer))
 		return FAIL;
 
@@ -503,7 +503,7 @@ int	zbx_dbsync_compare_hosts(zbx_dbsync_t *sync)
 	zbx_uint64_t		rowid;
 	ZBX_DC_HOST		*host;
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	if (NULL == (result = DBselect(
 			"select hostid,proxy_hostid,host,ipmi_authtype,ipmi_privilege,ipmi_username,"
 				"ipmi_password,maintenance_status,maintenance_type,maintenance_from,"
diff --git a/src/libs/zbxdbhigh/proxy.c b/src/libs/zbxdbhigh/proxy.c
index c6877e1..e499773 100644
--- a/src/libs/zbxdbhigh/proxy.c
+++ b/src/libs/zbxdbhigh/proxy.c
@@ -177,7 +177,7 @@ int	check_access_passive_proxy(zbx_socket_t *sock, int send_response, const char
 		return FAIL;
 	}
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	if (ZBX_TCP_SEC_TLS_CERT == sock->connection_type && SUCCEED != zbx_check_server_issuer_subject(sock, &msg))
 	{
 		zabbix_log(LOG_LEVEL_WARNING, "%s from server is not allowed: %s", req, msg);
@@ -2044,12 +2044,12 @@ void	process_mass_data(zbx_socket_t *sock, zbx_uint64_t proxy_hostid, AGENT_VALU
 	int			*lastclocks = NULL, *errcodes = NULL, *mtimes = NULL, *errcodes2 = NULL,
 				flag_host_allow = 0;
 	size_t			num = 0;
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	zbx_tls_conn_attr_t	attr;
 #endif
 	zabbix_log(LOG_LEVEL_DEBUG, "In %s()", __function_name);
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	if (0 == proxy_hostid &&
 			((ZBX_TCP_SEC_TLS_CERT == sock->connection_type &&
 				SUCCEED != zbx_tls_get_attr_cert(sock, &attr)) ||
@@ -2157,7 +2157,7 @@ void	process_mass_data(zbx_socket_t *sock, zbx_uint64_t proxy_hostid, AGENT_VALU
 					continue;
 				}
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 				if (ZBX_TCP_SEC_TLS_CERT == sock->connection_type)
 				{
 					/* simplified match, not compliant with RFC 4517, 4518 */
diff --git a/src/libs/zbxnix/coredump.c b/src/libs/zbxnix/coredump.c
index fc32d73..f5c8917 100644
--- a/src/libs/zbxnix/coredump.c
+++ b/src/libs/zbxnix/coredump.c
@@ -21,7 +21,7 @@
 #include "log.h"
 #include "zbxnix.h"
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 /******************************************************************************
  *                                                                            *
  * Function: zbx_coredump_disable                                             *
